
#import "XoxWars.h"
#import "TrackMander.h"
#import "XWShip.h"

@implementation TrackMander

- init
{
	[super init];
	tracks = [[List alloc] init];
	return self;
}

- addShip:ship
{
	[self addTrack:[[Tracker alloc] initFor:ship]];
	return [super addShip:ship];
}

- addTrack:track
{
	[tracks addObject:track];
  return self;
}


#define checkBullets() ([scenario hasBullets:alliance])

- oneStep:scenario
{
	extern float frandom(void);

	int n = [tracks count];
	int ne = [targets count];

	while (n--) {
		Tracker* track = [tracks objectAt:n];
		SEL mode;
		[track track:[targets objectAt:(n%ne)]];
		[track shieldsWithin:250.0];
		if ([track distance] < 100.0) {
				mode = @selector(turnTowards);
		} else if ([track velocity] > [track distance]/10.0) {
			mode = @selector(matchVelocity);
		} else {
			mode = @selector(thrustTowards);
		}
		if ([track perform:mode] && [scenario hasBullets:alliance])
			[track fireBetween:200.0 :50.0];
	}
	return self;
}
@end