
#import <appkit/appkit.h>

#import "Actor.h"
#import "Ship.h"

typedef enum {X_AXIS, Y_AXIS, N_AXIS} AXIS;

@interface Tracker:Object
{
	Ship*	ship;
	Actor*	to;
	float x[N_AXIS];
	float v[N_AXIS];
	float resolution;
}

- initFor:aShip;
- track:target;

- ship;
- target;

- setResolution:(float) res;

- update;
- (float) distance;
- (float) angle;

- (float) velocity;
- (float) Vangle; //velocity angle

/*
 *  Control sequences
 */
- (BOOL) turnTowards;

- (BOOL) turnTowards:(float)angle;

- (BOOL) thrustTowards;

- (BOOL) thrustTowards:(float)angle;

- (BOOL) matchVelocity;

- (BOOL) fireBetween:(float)far :(float)near;

- (BOOL) shieldsWithin:(float)distance;


@end

@interface Ship (Tracker)

- (float) velocity:(Actor*)to axis:(AXIS)xy;
- (float) distance:(Actor*)to axis:(AXIS)xy;
- (float) angle;

@end
